/*
 * Segunda tentativa de implementação do algoritmo da padaria.
 */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define N 10

volatile int s = 0; /* Variável compartilhada */
volatile int num[N]; /* Vetor de senhas */

/* Retorna o valor máximo presente no vetor num */
int max() {
  int i, m = num[0];
  for (i = 1; i < N; i++) 
    if (m < num[i]) 
      m = num[i];
  return m;
}

void* f_thread(void *v) {
  int thr_id = *(int *)v; 
  int i, j;

  for (i = 0; i < 10; i++) {
    num[thr_id] = max() + 1; /* Calcula senha */
   
   for (j = 0; j < N; j++)
     while (num[j] != 0 && 
	    (num[j] < num[thr_id] || (num[j] == num[thr_id] && j < thr_id)));
   
   s = thr_id;
   sleep(1);
   printf("Thread %d, s = %d.\n", thr_id, s); 
   
   num[thr_id] = 0;  /* Marca que saiu da região crítica */
   sleep(1);
  }
  return NULL;
}

int main() {
  pthread_t thr[N];
  int i, id[N];

  for (i = 0; i < N; i++) 
    num[i] = 0;

  for (i = 0; i < N; i++) {
    id[i] = i;
    pthread_create(&thr[i], NULL, f_thread, &id[i]);
  }

  for (i = 0; i < N; i++) 
    pthread_join(thr[i], NULL); 

  return 0;
}

